# tank 0

import game
from basegroundobj import *

XACCEL = 0.22
FRICTION = 0.97

# min space between player and tank
GUARD_DIST = 40

MAX_DX = game.groundspeed * 5
MIN_DX = -game.groundspeed * 1.5



name = 'tank0'
type = 'gif'

image = None

def load_game_resources():
    global image, name
    image = gfx.load('%s.%s' % (name,type))


class Tank0(GroundObj):

    # class variables
    max = 1
    count = 0

    def __init__(self):
        global name,image
        GroundObj.__init__(self,name,image)

        self.xaccel = XACCEL

    def tick(self, speedadjust):

        if self.rect.left < game.player.rect.right + GUARD_DIST:
            self.dx += self.xaccel
        elif self.rect.left < game.player.rect.right + 2 * GUARD_DIST:
            self.dx += 0
        else:
            self.dx += -self.xaccel

        self.dx = ((self.dx + game.groundspeed) * FRICTION) - game.groundspeed

        if self.dx < MIN_DX:
            self.dx = MIN_DX
        elif self.dx > MAX_DX:
            self.dx = MAX_DX

        self.x += self.dx * speedadjust

        if self.x < gfx.rect.left - self.rect.width:
            self.dead = 1

        self.rect.topleft = [self.x,self.y]



    
